function jpibfi_pinit(options) {
	var $ = jQuery;

	var defaults = {
		pageURL        : document.URL,
		pageTitle      : document.title,
		pageDescription: $('meta[name="description"]').attr('content')
	}

	var o = $.extend(defaults, options);
	var discriminator_classes = o.disabled_classes.split(';');

	if (!(typeof o.enabled_classes === 'undefined')) //variable exists
		var allowed_classes = o.enabled_classes.split(';');

	$(o.image_selector).each(function (i) {
		var e = $(this);
		//check if the image has a discriminator class, if has, then return
		for (var c in discriminator_classes) {
			if (e.hasClass(discriminator_classes[c]))
				return;
		}

		if (!(typeof allowed_classes === 'undefined')) {//variable doesn't exist
			var has_class = false;
			for (var c in allowed_classes) {
				if (e.hasClass(allowed_classes[c])) {
					has_class = true;
					break;
				}
			}
			if (!has_class)
				return;
		}

		//to identify the image when loaded
		e.attr('data-indexer', i);
	});

	window.onload = function () {

		var wpclasses = ['alignnone', 'alignright', 'alignleft'];

		$("img[data-indexer]").each(function () {
			var image = $(this),
					pi_url = o.pageURL;

			//Pin message depending on settings
			var pi_desc;
			if (o.description_option == 3)
				pi_desc = image.attr('title') ? image.attr('title') : image.attr('alt');
			else if (o.description_option == 2)
				pi_desc = o.pageDescription;
			!pi_desc && (pi_desc = o.pageTitle);

			var indexer = image.attr("data-indexer"),
					bookmark = 'http://pinterest.com/pin/create/bookmarklet/?url=' + encodeURI(pi_url) + '&is_video=' + encodeURI('false') + '&description=' + encodeURI(pi_desc),
					height = this.clientHeight,
					width = this.clientWidth;

			image.wrap('<div class="pinit" data-indexer="' + indexer + '"/>');
			image.after('<span class="pinit-overlay" data-indexer= "' + indexer + '"><a class="pinit-button" href="' + bookmark + '" data-indexer= "' + indexer + '">Pin It</a></span>');
			image.attr('height', height + 'px').attr('width', width + 'px');

			$('span.pinit-overlay[data-indexer="' + indexer + '"]')
					.css({
						height         :height + 'px',
						width          :width + 'px',
						'margin-right' :image.css('margin-right'),
						'margin-left'  :image.css('margin-left'),
						'margin-top'   :image.css('margin-top'),
						'margin-bottom':image.css('margin-bottom')
					});

			for (var i in wpclasses)
				image.hasClass(wpclasses[i]) && $('span.pinit[data-indexer="' + indexer + '"]').addClass(wpclasses[i]);

			if (image.hasClass('aligncenter')) {
				$('.pinit[data-indexer="' + indexer + '"]')
						.addClass('aligncenter')
						.css('clear', 'both');
				$('span.pinit-overlay[data-indexer="' + indexer + '"]')
						.css({
							"margin-left" :"auto",
							"margin-right":"auto",
							left          :0,
							right         :0
						})
			}

			$('.pinit .pinit-button').click( function () {
				var index = $(this).attr("data-indexer");
				var image = $('img[data-indexer="' + index+ '"]');
				var url = $(this).attr('href') + "&media=" + encodeURI ( image.data('media') ? image.data('media') : image[0].src );
				window.open(url, 'Pinterest', 'width=632,height=253,status=0,toolbar=0,menubar=0,location=1,scrollbars=1');
				return false;
			});

			$('.pinit').mouseenter(function () {
				$(this).children('.pinit-overlay').fadeIn(200);
			}).mouseleave(function () {
				$(this).children('.pinit-overlay').fadeOut(200);
			});
		})
	};
}

